com.io7m.r2.core.shaders.provided

## Class R2DepthShaderBasicStippledParameters

- java.lang.Object
- - com.io7m.r2.core.shaders.provided.R2DepthShaderBasicStippledParameters

- All Implemented Interfaces:
    R2DepthShaderBasicParametersValuesType, R2DepthShaderBasicStippledParametersType

      @Generated(value={"Immutables.generator","R2DepthShaderBasicStippledParametersType"})
      public final class R2DepthShaderBasicStippledParameters
      extends Object
      implements R2DepthShaderBasicStippledParametersType

  The type of parameters for the basic stippled depth shader.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `R2DepthShaderBasicStippledParameters.Builder` Builds instances of type `R2DepthShaderBasicStippledParameters`.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `R2Texture2DUsableType` | `albedoTexture()` An albedo map which is used primarily used to determine the opacity of the shaded surface.
    `float` | `alphaDiscardThreshold()` The threshold value that defines whether or not the surface fragment will be discarded.
    `static R2DepthShaderBasicStippledParameters.Builder` | `builder()` Creates a builder for `R2DepthShaderBasicStippledParameters`.
    `static R2DepthShaderBasicStippledParameters` | `copyOf(R2DepthShaderBasicStippledParametersType instance)` Creates an immutable copy of a `R2DepthShaderBasicStippledParametersType` value.
    `boolean` | `equals(Object another)` This instance is equal to all instances of `R2DepthShaderBasicStippledParameters` that have equal attribute values.
    `int` | `hashCode()` Computes a hash code from attributes: `textureDefaults`, `albedoTexture`, `alphaDiscardThreshold`, `stippleNoiseTexture`, `stippleThreshold`.
    `static R2DepthShaderBasicStippledParameters` | `of(R2TextureDefaultsType textureDefaults, R2Texture2DUsableType albedoTexture, float alphaDiscardThreshold, R2Texture2DUsableType stippleNoiseTexture, float stippleThreshold)` Construct a new immutable `R2DepthShaderBasicStippledParameters` instance.
    `R2Texture2DUsableType` | `stippleNoiseTexture()` The noise texture used to implement stippling.
    `float` | `stippleThreshold()` The stipple threshold value.
    `R2TextureDefaultsType` | `textureDefaults()`
    `String` | `toString()` Prints the immutable value `R2DepthShaderBasicStippledParameters` with attribute values.
    `R2DepthShaderBasicStippledParameters` | `withAlbedoTexture(R2Texture2DUsableType value)` Copy the current immutable object by setting a value for the `albedoTexture` attribute.
    `R2DepthShaderBasicStippledParameters` | `withAlphaDiscardThreshold(float value)` Copy the current immutable object by setting a value for the `alphaDiscardThreshold` attribute.
    `R2DepthShaderBasicStippledParameters` | `withStippleNoiseTexture(R2Texture2DUsableType value)` Copy the current immutable object by setting a value for the `stippleNoiseTexture` attribute.
    `R2DepthShaderBasicStippledParameters` | `withStippleThreshold(float value)` Copy the current immutable object by setting a value for the `stippleThreshold` attribute.
    `R2DepthShaderBasicStippledParameters` | `withTextureDefaults(R2TextureDefaultsType value)` Copy the current immutable object by setting a value for the `textureDefaults` attribute.

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Method Detail

    - #### textureDefaults

          public R2TextureDefaultsType textureDefaults()

      Specified by:
        `textureDefaults` in interface `R2DepthShaderBasicParametersValuesType`
      Specified by:
        `textureDefaults` in interface `R2DepthShaderBasicStippledParametersType`
      Returns:
        The value of the `textureDefaults` attribute

    - #### albedoTexture

          public R2Texture2DUsableType albedoTexture()

      Description copied from interface: `R2DepthShaderBasicParametersValuesType`

      An albedo map which is used primarily used to determine the opacity of the shaded surface.

      Specified by:
        `albedoTexture` in interface `R2DepthShaderBasicParametersValuesType`
      Specified by:
        `albedoTexture` in interface `R2DepthShaderBasicStippledParametersType`
      Returns:
        The value of the `albedoTexture` attribute

    - #### alphaDiscardThreshold

          public float alphaDiscardThreshold()

      Description copied from interface: `R2DepthShaderBasicParametersValuesType`
      The threshold value that defines whether or not the surface fragment will be discarded. If the opacity of the surface is less than this threshold value, the surface will be discarded. A threshold value of `0.0` will result in no fragments ever being discarded.
      Specified by:
        `alphaDiscardThreshold` in interface `R2DepthShaderBasicParametersValuesType`
      Specified by:
        `alphaDiscardThreshold` in interface `R2DepthShaderBasicStippledParametersType`
      Returns:
        The value of the `alphaDiscardThreshold` attribute

    - #### stippleNoiseTexture

          public R2Texture2DUsableType stippleNoiseTexture()

      The noise texture used to implement stippling. This is a random noise texture that is tiled across the screen, and values in the red channel are sampled for stippling.
      Specified by:
        `stippleNoiseTexture` in interface `R2DepthShaderBasicStippledParametersType`
      Returns:
        A noise texture
      See Also:
        `stippleThreshold()`

    - #### stippleThreshold

          public float stippleThreshold()

      The stipple threshold value. For each pixel in the surface, the stipple threshold determine whether or not that pixel will be discarded. Essentially, the `stippleNoiseTexture()` is sampled at each pixel, and if the sampled value is less than `stippleThreshold()`, the pixel is discarded. Consequently, a stipple threshold of `0.0` never discards pixels.
      Specified by:
        `stippleThreshold` in interface `R2DepthShaderBasicStippledParametersType`
      Returns:
        The threshold value

    - #### withTextureDefaults

          public final R2DepthShaderBasicStippledParameters withTextureDefaults(R2TextureDefaultsType value)

      Copy the current immutable object by setting a value for the `textureDefaults` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
      Parameters:
        `value` - A new value for textureDefaults
      Returns:
        A modified copy of the `this` object

    - #### withAlbedoTexture

          public final R2DepthShaderBasicStippledParameters withAlbedoTexture(R2Texture2DUsableType value)

      Copy the current immutable object by setting a value for the `albedoTexture` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
      Parameters:
        `value` - A new value for albedoTexture
      Returns:
        A modified copy of the `this` object

    - #### withAlphaDiscardThreshold

          public final R2DepthShaderBasicStippledParameters withAlphaDiscardThreshold(float value)

      Copy the current immutable object by setting a value for the `alphaDiscardThreshold` attribute. A value strict bits equality used to prevent copying of the same value by returning `this`.
      Parameters:
        `value` - A new value for alphaDiscardThreshold
      Returns:
        A modified copy of the `this` object

    - #### withStippleNoiseTexture

          public final R2DepthShaderBasicStippledParameters withStippleNoiseTexture(R2Texture2DUsableType value)

      Copy the current immutable object by setting a value for the `stippleNoiseTexture` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
      Parameters:
        `value` - A new value for stippleNoiseTexture
      Returns:
        A modified copy of the `this` object

    - #### withStippleThreshold

          public final R2DepthShaderBasicStippledParameters withStippleThreshold(float value)

      Copy the current immutable object by setting a value for the `stippleThreshold` attribute. A value strict bits equality used to prevent copying of the same value by returning `this`.
      Parameters:
        `value` - A new value for stippleThreshold
      Returns:
        A modified copy of the `this` object

    - #### equals

          public boolean equals(Object another)

      This instance is equal to all instances of `R2DepthShaderBasicStippledParameters` that have equal attribute values.
      Overrides:
        `equals` in class `Object`
      Returns:
        `true` if `this` is equal to `another` instance

    - #### hashCode

          public int hashCode()

      Computes a hash code from attributes: `textureDefaults`, `albedoTexture`, `alphaDiscardThreshold`, `stippleNoiseTexture`, `stippleThreshold`.
      Overrides:
        `hashCode` in class `Object`
      Returns:
        hashCode value

    - #### toString

          public String toString()

      Prints the immutable value `R2DepthShaderBasicStippledParameters` with attribute values.
      Overrides:
        `toString` in class `Object`
      Returns:
        A string representation of the value

    - #### of

          public static R2DepthShaderBasicStippledParameters of(R2TextureDefaultsType textureDefaults,
                                                                R2Texture2DUsableType albedoTexture,
                                                                float alphaDiscardThreshold,
                                                                R2Texture2DUsableType stippleNoiseTexture,
                                                                float stippleThreshold)

      Construct a new immutable `R2DepthShaderBasicStippledParameters` instance.
      Parameters:
        `textureDefaults` - The value for the `textureDefaults` attribute
        `albedoTexture` - The value for the `albedoTexture` attribute
        `alphaDiscardThreshold` - The value for the `alphaDiscardThreshold` attribute
        `stippleNoiseTexture` - The value for the `stippleNoiseTexture` attribute
        `stippleThreshold` - The value for the `stippleThreshold` attribute
      Returns:
        An immutable R2DepthShaderBasicStippledParameters instance

    - #### copyOf

          public static R2DepthShaderBasicStippledParameters copyOf(R2DepthShaderBasicStippledParametersType instance)

      Creates an immutable copy of a `R2DepthShaderBasicStippledParametersType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
      Parameters:
        `instance` - The instance to copy
      Returns:
        A copied immutable R2DepthShaderBasicStippledParameters instance

    - #### builder

          public static R2DepthShaderBasicStippledParameters.Builder builder()

      Creates a builder for `R2DepthShaderBasicStippledParameters`.
      Returns:
        A new R2DepthShaderBasicStippledParameters builder

Copyright © 2017 <code@io7m.com> http://io7m.com